using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart.Styles;
using Steema.TeeChart.Tools;


namespace CS_CursorToolIntersection
{
    public partial class Form1 : Form
    {
       private void Form1_Load(object sender, EventArgs e)
        {

        }
        public Form1()
        {
            InitializeComponent();

            InitializeChart();
        }

        Steema.TeeChart.Tools.CursorTool cursor1;

        private double InterpolateLineSeries(Steema.TeeChart.Styles.Custom series, int firstindex, int lastindex, double xvalue)
        {
            int index;
            for (index = firstindex; index <= lastindex; index++)
            {
                if (index == -1 || series.XValues.Value[index] > xvalue) break;
            }
            // safeguard
            if (index < 1) index = 1;
            else if (index >= series.Count) index = series.Count - 1;
            // y=(y2-y1)/(x2-x1)*(x-x1)+y1
            double dx = series.XValues[index] - series.XValues[index - 1];
            double dy = series.YValues[index] - series.YValues[index - 1];
            if (dx != 0.0) return dy * (xvalue - series.XValues[index - 1]) / dx + series.YValues[index - 1];
            else return 0.0;
        }

        private double InterpolateLineSeries(Steema.TeeChart.Styles.Custom series, double xvalue)
        {
            return InterpolateLineSeries(series, series.FirstVisibleIndex, series.LastVisibleIndex, xvalue);
        }


        private void InitializeChart()
        {
            chartController1.Chart = tChart1;
            tChart1.Aspect.View3D = false;

            for (int i = 0; i < 3; i++)
            {
                new Steema.TeeChart.Styles.Line(tChart1.Chart);
                tChart1[i].FillSampleValues(50);

                new Steema.TeeChart.Tools.Annotation(tChart1.Chart);
            }

            cursor1 = new Steema.TeeChart.Tools.CursorTool(tChart1.Chart);
            cursor1.FollowMouse = true;
            cursor1.Change += new Steema.TeeChart.Tools.CursorChangeEventHandler(cursor1_Change);
        }

        void cursor1_Change(object sender, Steema.TeeChart.Tools.CursorChangeEventArgs e)
        {
            int ys;
            double YValue;
            int xs = tChart1.Axes.Bottom.CalcXPosValue(e.XValue);

            for (int i = 0; i < tChart1.Series.Count; i++)
                if (tChart1.Series[i] is Steema.TeeChart.Styles.Custom)
                {
                    YValue = InterpolateLineSeries(tChart1.Series[i] as Steema.TeeChart.Styles.Custom, e.XValue);
                    ys = tChart1.Series[i].GetVertAxis.CalcYPosValue(YValue);
                    ((Steema.TeeChart.Tools.Annotation)tChart1.Tools[i]).Left = xs;
                    ((Steema.TeeChart.Tools.Annotation)tChart1.Tools[i]).Top = ys;
                    ((Steema.TeeChart.Tools.Annotation)tChart1.Tools[i]).Text = tChart1.Series[i].Title + ": Y(" + e.XValue.ToString("0.00") + ")= ";
                    ((Steema.TeeChart.Tools.Annotation)tChart1.Tools[i]).Text += YValue.ToString("0.00") + "\r\n";
                }

        }

        private void ChangeDataBtn_Click(object sender, EventArgs e)
        {
            tChart1.Series.Clear(true);
            for (int i = 0; i < 3; i++)
            {
                new Steema.TeeChart.Styles.Line(tChart1.Chart);
                tChart1[i].FillSampleValues(50);
            }
        }

        private void SaveBtn_Click(object sender, EventArgs e)
        {
            tChart1.Export.Template.IncludeData = true;
            tChart1.Export.Template.Save("C:\\test2.ten");
        }

        private void RestoreBtn_Click(object sender, EventArgs e)
        {
            tChart1.Import.Template.Load("C:\\test2.ten");
        }
    }
}